% MATLAB function for Oblique, Varimax, and Procrustes rotation
function [Lobl,T,phi]=FArot(L,rotmethod,TL)
n=size(L,1);
Lobl=L;
T=eye(n);phi=0;
if rotmethod==1
    [Lobl,phi,T]=GPFoblq(L,eye(size(L,2)));   % Oblimin
end
if rotmethod==2 % Varimax
    [Lobl, T]=rotatefactors(L,'method','promax','power',4,'Reltol',10^-6,'Maxit',999,'Normalize',1);
    phi=inv(T'*T);
end
if rotmethod==3 % Procrustes
    if ~isequal(size(L),size(TL))  % in the case of overextraction or underextraction, first do oblimin and then reordering
        L=FArot(L,1,TL);
        [L,TL]   =ordering(L,TL);
    end
    [Lobl, T]=rotatefactors(L,'method','procrustes','target',TL);
    phi=inv(T'*T);
end