% General GPF subroutine for oblique rotation taken from Bernaards & Jennrich (2005)
% Reference: Bernaards, C. A., & Jennrich, R. I. (2005). Gradient
% projection algorithms and software for arbitrary rotation criteria in
% factor analysis. Educational and Psychological Measurement, 65, 676-696.
% Website: https://web.archive.org/web/20150407000957/http://www.stat.ucla.edu/research/
function [Lh,Phi,Th]=GPFoblq(A,T)
al=1;
Ti=inv(T);
L=A*Ti';
[f,Gq]=vgQoblimin(L);
G=-(L'*Gq*Ti)'; %#ok<MINV>
for iter=0:500
    Gp=G-T*diag(sum(T.*G));
    s=norm(Gp,'fro');
    if s<10^(-5),break,end
    al=2*al;
    for i=0:10
        X=T-al*Gp;
        v=1./sqrt(sum(X.^2));
        Tt=X*diag(v);
        Ti=inv(Tt);
        L=A*Ti';
        [ft,Gq]=vgQoblimin(L);
        if ft<f-.5*s^2*al,break,end
        al=al/2;
    end
    T=Tt;
    f=ft;
    G=-(L'*Gq*Ti)';
end
Th=T;
Lh=L;
Phi=T'*T;