% MATLAB function for principal axis factoring
function [lding, c, k]=paf(r,f,tol,itermax)
c=1 - 1 ./ diag(r \ diag(ones(length(r),1))); % initial communalities
rzero=r-eye(size(r));
for k=1:itermax
    [V,D]=svd(rzero+diag(c));
    D=diag(D);
    V=V(:,(1:f));
    lding=V * diag(D(1:f,:))^.5;
    cb=c;
    c=sum(lding.^2,2);
    if sum(c>1)>0 % stop iterating if one or more variables yield a Heywood case
        break
    end
    if max(abs(c - cb))<tol % stop iterating if the change in communalities is sufficiently small
        break
    end
end