% vgQ subroutine for the oblimin family taken from Bernaards and Jennrich (2005)
% Reference: Bernaards, C. A., & Jennrich, R. I. (2005). Gradient
% projection algorithms and software for arbitrary rotation criteria in
% factor analysis. Educational and Psychological Measurement, 65, 676-696.
% Website: https://web.archive.org/web/20150407000957/http://www.stat.ucla.edu/research/
function [q,Gq]=vgQoblimin(L)
gm=0;
L2=L.^2;
[p,k]=size(L);
N=ones(k,k)-eye(k);
C=ones(p,p)/p;
X=(eye(p)-gm*C)*L2*N;
q=sum(sum(L2.*X))/4;
Gq=L.*X;